package DiffPrinter::raw;

use strict;

sub new {
  my $class = shift;
  $class = ref($class) || $class;
  my $this = {};
  bless $this, $class;

  return $this;
}

sub start_patch {
}

sub end_patch {
}

sub start_file {
  my $this = shift;
  my ($file) = @_;

  if ($file->{rcs_filename}) {
    print "Index: $file->{filename}\n";
    print "===================================================================\n";
    print "RCS file: $file->{rcs_filename}\n";
  }
  my $old_file = $file->{is_add} ? "/dev/null" : $file->{filename};
  my $old_date = $file->{old_date_str} || "";
  print "--- $old_file\t$old_date";
  print "\t$file->{old_revision}" if $file->{old_revision};
  print "\n";
  my $new_file = $file->{is_remove} ? "/dev/null" : $file->{filename};
  my $new_date = $file->{new_date_str} || "";
  print "+++ $new_file\t$new_date";
  print "\t$file->{new_revision}" if $file->{new_revision};
  print "\n";
}

sub end_file {
}

sub section {
  my $this = shift;
  my ($section) = @_;

  print "@@ -$section->{old_start},$section->{old_lines} +$section->{new_start},$section->{new_lines} @@\n";
  foreach my $line (@{$section->{lines}}) {
    $line =~ s/(\r?\n?)$/\n/;
    print $line;
  }
}

1
