package PatchIterator::NarrowPatchIterator;

use PatchIterator::BasePatchIterator;
use CVSClient;

use strict;

@PatchIterator::NarrowPatchIterator::ISA = qw(PatchIterator::BasePatchIterator);

sub new {
  my $class = shift;
  $class = ref($class) || $class;
  my $this = $class->SUPER::new();
  bless $this, $class;

  $this->{INCLUDE_FILES} = [@_];

  return $this;
}

sub start_patch {
  my $this = shift;
  $this->{TARGET}->start_patch(@_);
}

sub end_patch {
  my $this = shift;
  $this->{TARGET}->end_patch(@_);
}

sub start_file {
  my $this = shift;
  my ($file) = @_;
  if (grep { $_ eq substr($file->{filename}, 0, length($_)) } @{$this->{INCLUDE_FILES}}) {
    $this->{IS_INCLUDED} = 1;
    $this->{TARGET}->start_file(@_);
  }
}

sub end_file {
  my $this = shift;
  if ($this->{IS_INCLUDED}) {
    $this->{TARGET}->end_file(@_);
    $this->{IS_INCLUDED} = 0;
  }
}

sub section {
  my $this = shift;
  if ($this->{IS_INCLUDED}) {
    $this->{TARGET}->section(@_);
  }
}

1
